#-*- coding: utf-8 -*-
#
# Jointure_FILM_liste_de_listes.py
 
from os import chdir
from os import listdir

# Se déplacer dans le dossier en cours si besoin
path = r'P:\PRO\USB\NSI\NSI DONNEES EN TABLE'
chdir(path)

import csv

from copy import deepcopy

# Fusion, jointure de deux tables qui possèdent un attribut commun : attribut_commun
def jointure(table1, table2, attribut_commun):
    
    # Trouver la position de attribut_commun dans la liste table1
    # dans le descripteur donc l'index [0]
    index1 = table1[0].index(attribut_commun)

    # Trouver la position de attribut_commun dans la liste table2
    # dans le descripteur donc l'index [0]
    index2 = table2[0].index(attribut_commun)    

        
    new_table = []
    for ligne1 in range(0,len(table1)):
        for ligne2 in range(0,len(table2)):
            if table1[ligne1][index1] == table2[ligne2][index2]:
                new_line = table1[ligne1][::]  # deepcopy de la table1
                for x in range(len(table2[0])):
                    if  x != index2:
                        new_line.append(table2[ligne2][x]) # puis ajout des éléments
                new_table.append(new_line)                 # de la table 2
                                                           # sauf l'attribut commun

    return new_table


# On créer la liste vide
table_coordonnees=[]
 
# Lecture de la table csv, le résultat est dans une 
# liste de listes
with open('COORDONNEES.CSV', encoding="utf8") as myFile:
    reader = csv.reader(myFile,delimiter=';')
    for row in reader:  
        table_coordonnees.append(row)	

# On créer la liste vide
table_seances=[]
 
# Lecture de la table csv, le résultat est dans une 
# liste de listes
with open('SEANCES.CSV', encoding="utf8") as myFile:
    reader = csv.reader(myFile,delimiter=';')
    for row in reader:  
        table_seances.append(row)	
        
table_jointure = jointure(table_coordonnees,table_seances,'Salle')

print("Table créée par jointure sur les tables Coordonnees Seances \
avec l'attribut commun Salle")

for x in range(1,len(table_jointure)):
    print(table_jointure[x])    

print()
print() 

    
# Création d'un fichier .csv résultat de la jointure
nomFichier = "JOINTURE_TABLE_FROM_LISTE.csv"

with open(nomFichier,'w',encoding="utf8",newline='') as csvfile:
    writer = csv.writer(csvfile, delimiter=';')
    writer.writerows(table_jointure)

