#-*- coding: utf-8 -*-
#
# Lecture_FILM_liste_de_dictionnaires.py
 
from os import chdir
from os import listdir

# Se déplacer dans le dossier en cours si besoin
path = r'P:\PRO\USB\NSI\NSI DONNEES EN TABLE'
chdir(path)

import csv

# On créer la liste vide
table=[]
 
# Lecture de la table csv, le résultat est dans une 
# liste de dictionnaires
with open('FILM.CSV', encoding="utf8") as myFile:
    reader = csv.DictReader(myFile,delimiter=';')
    for row in reader:  
        table.append(row)	
        
for x in range(len(table)):
    print(table[x])

print()
print()
    
# Sélection de lignes : quels sont les films dirigés par Bergman 
# avec doublons
liste_lignes = [ x['Titre'] for x in table if x['Directeur'] == 'Spielberg']

print('Les films dirigés par Bergman avec doublons : ')
for x in range(len(liste_lignes)):
    print(liste_lignes[x])

print()
print()


# Sélection de lignes : quels sont les films dirigés par Bergman 
# sans doublons
# utilisation d'un ensemble
liste_lignes_sd = set([ x['Titre'] for x in table if x['Directeur']=='Spielberg'])

print('Les films dirigés par Bergman sans doublons : ')
for x in liste_lignes_sd:
    print(x)

print()
print()
    
# Sélection de colonnes :
liste_colonnes = [{"Directeur":ligne["Directeur"],"Acteur":ligne["Acteur"]} for ligne in table]

print('Table créée par projection sur la table film attribut Directeur, Acteur :')
for x in range(len(liste_colonnes)):
    print(liste_colonnes[x])    

print()
print()
 
    
# Sélection de colonnes solution alternative 
# Montre comment utiliser ce principe dans une fonction qui recevrait une liste
# d'attributs
liste_attributs = ['Acteur','Directeur']
liste_colonnes = [{cle:ligne[cle] 
                    for cle in ligne 
                        if cle in liste_attributs} for ligne in table]

print('Table créée par projection sur la table film attribut Directeur, Acteur :')
for x in range(len(liste_colonnes)):
    print(liste_colonnes[x])            